"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var MongoMemoryReplSet_1 = __importDefault(require("../MongoMemoryReplSet"));
var tmp = __importStar(require("tmp"));
var tmpDir;
beforeEach(function () {
    tmpDir = tmp.dirSync({ prefix: 'reuse-mongo-mem-', unsafeCleanup: true });
});
afterEach(function () {
    tmpDir.removeCallback();
});
var sleep = function (ms) {
    return new Promise(function (resolve) { return setTimeout(resolve, ms); });
};
describe('single-member replica set', function () {
    it('should start multiple times', function () { return __awaiter(void 0, void 0, void 0, function () {
        var opts, replSetBefore, _a, replSetAfter;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    opts = {
                        replSet: {
                            storageEngine: 'wiredTiger',
                        },
                        instanceOpts: [
                            {
                                port: 27017,
                                dbPath: tmpDir.name,
                            },
                        ],
                    };
                    replSetBefore = new MongoMemoryReplSet_1.default(opts);
                    return [4 /*yield*/, replSetBefore.waitUntilRunning()];
                case 1:
                    _b.sent();
                    // Write real port to config (because 27017 may be busy, we need to get real port)
                    // eslint-disable-next-line @typescript-eslint/no-non-null-assertion
                    _a = opts.instanceOpts[0];
                    return [4 /*yield*/, replSetBefore.servers[0].getPort()];
                case 2:
                    // Write real port to config (because 27017 may be busy, we need to get real port)
                    // eslint-disable-next-line @typescript-eslint/no-non-null-assertion
                    _a.port = _b.sent();
                    return [4 /*yield*/, replSetBefore.stop()];
                case 3:
                    _b.sent();
                    /**
                     * get-port has a portlocking-feature that keeps ports locked for
                     * "a minimum of 15 seconds and a maximum of 30 seconds before being released again"
                     * https://github.com/sindresorhus/get-port#beware
                     */
                    return [4 /*yield*/, sleep(30000)];
                case 4:
                    /**
                     * get-port has a portlocking-feature that keeps ports locked for
                     * "a minimum of 15 seconds and a maximum of 30 seconds before being released again"
                     * https://github.com/sindresorhus/get-port#beware
                     */
                    _b.sent();
                    replSetAfter = new MongoMemoryReplSet_1.default(opts);
                    return [4 /*yield*/, replSetAfter.waitUntilRunning()];
                case 5:
                    _b.sent();
                    return [4 /*yield*/, replSetAfter.stop()];
                case 6:
                    _b.sent();
                    return [2 /*return*/];
            }
        });
    }); }, 600000);
});
//# sourceMappingURL=replset-single-restart-test.js.map