"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var mongodb_1 = require("mongodb");
var MongoMemoryServer_1 = __importDefault(require("../MongoMemoryServer"));
jasmine.DEFAULT_TIMEOUT_INTERVAL = 600000;
var con;
var db;
var mongoServer;
beforeAll(function () { return __awaiter(void 0, void 0, void 0, function () {
    var mongoUri, _a, _b;
    return __generator(this, function (_c) {
        switch (_c.label) {
            case 0:
                mongoServer = new MongoMemoryServer_1.default();
                return [4 /*yield*/, mongoServer.getConnectionString()];
            case 1:
                mongoUri = _c.sent();
                return [4 /*yield*/, mongodb_1.MongoClient.connect(mongoUri, {
                        useNewUrlParser: true,
                        useUnifiedTopology: true,
                    })];
            case 2:
                con = _c.sent();
                _b = (_a = con).db;
                return [4 /*yield*/, mongoServer.getDbName()];
            case 3:
                db = _b.apply(_a, [_c.sent()]);
                return [2 /*return*/];
        }
    });
}); });
afterAll(function () { return __awaiter(void 0, void 0, void 0, function () {
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                if (con)
                    con.close();
                if (!mongoServer) return [3 /*break*/, 2];
                return [4 /*yield*/, mongoServer.stop()];
            case 1:
                _a.sent();
                _a.label = 2;
            case 2: return [2 /*return*/];
        }
    });
}); });
describe('Single mongoServer', function () {
    it('should start mongo server', function () { return __awaiter(void 0, void 0, void 0, function () {
        var col, result, _a;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    expect(db).toBeDefined();
                    col = db.collection('test');
                    return [4 /*yield*/, col.insertMany([{ a: 1 }, { b: 1 }])];
                case 1:
                    result = _b.sent();
                    expect(result.result).toMatchSnapshot();
                    _a = expect;
                    return [4 /*yield*/, col.countDocuments({})];
                case 2:
                    _a.apply(void 0, [_b.sent()]).toBe(2);
                    return [2 /*return*/];
            }
        });
    }); });
    it('should get URI of specified DB name', function () { return __awaiter(void 0, void 0, void 0, function () {
        var port, _a;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0: return [4 /*yield*/, mongoServer.getPort()];
                case 1:
                    port = _b.sent();
                    _a = expect;
                    return [4 /*yield*/, mongoServer.getUri('dumb')];
                case 2:
                    _a.apply(void 0, [_b.sent()]).toBe("mongodb://127.0.0.1:" + port + "/dumb?");
                    return [2 /*return*/];
            }
        });
    }); });
    it('should throw error on start if there is already a running instance', function () { return __awaiter(void 0, void 0, void 0, function () {
        var mongoServer2;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    mongoServer2 = new MongoMemoryServer_1.default({ autoStart: false });
                    mongoServer2.runningInstance = Promise.resolve({});
                    return [4 /*yield*/, expect(mongoServer2.start()).rejects.toThrow('MongoDB instance already in status startup/running/error. Use debug for more info.')];
                case 1:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    }); });
});
//# sourceMappingURL=singleDB-test.js.map