"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var uuid_1 = require("uuid");
/**
 * Returns a database name string.
 * @param {string} dbName
 */
function generateDbName(dbName) {
    return dbName || uuid_1.v4();
}
exports.generateDbName = generateDbName;
/**
 * Extracts the host and port information from a mongodb URI string.
 * @param {string} uri mongodb URI
 */
function getHost(uri) {
    return uri.replace('mongodb://', '').replace(/\/.*/, '');
}
exports.getHost = getHost;
/**
 * Basic MongoDB Connection string
 */
function getUriBase(host, port, dbName) {
    return "mongodb://" + host + ":" + port + "/" + dbName + "?";
}
exports.getUriBase = getUriBase;
exports.default = generateDbName;
//# sourceMappingURL=db_util.js.map