export interface OtherOS {
    os: 'aix' | 'android' | 'darwin' | 'freebsd' | 'openbsd' | 'sunos' | 'win32' | 'cygwin' | string;
}
export interface LinuxOS extends OtherOS {
    os: 'linux';
    dist: string;
    release: string;
    codename?: string;
}
export declare type AnyOS = OtherOS | LinuxOS;
/**
 * Check if the OS is a LinuxOS Typeguard
 * @param os The OS object to check for
 */
export declare function isLinuxOS(os: AnyOS): os is LinuxOS;
/** Get an OS object */
export default function getOS(): Promise<AnyOS>;
//# sourceMappingURL=index.d.ts.map